
/***************************************************************************

                  D I R E C T O R Y - C O M M A N D E R

		
		  Holger Staeudte
		    IH Mittweida  1991
		
		  Rene Roellig  1993
		    Hochschule fuer Technik und Wirtschaft
		    Mittweida

***************************************************************************/


#include "dc.h"


extern int colors;

/********************************* maske1 **********************************/

WINDOW *maske1(win, m)
  int  m;
  WINDOW *win;
{
    if (m == W_DEL) {
	delwin(win);
	return (NULL);
    }
    if (m == W_NEW) {
	win = newwin(3, 80, 0, 0);
	if (colors) {
	    wattron(win, COLOR_PAIR(1));
	    werase(win);
	}
    }
    if (colors)
	wattron(win, COLOR_PAIR(1));
    box(win, ACS_VLINE, ACS_HLINE);
    return (win);
}


/********************************* maske2 **********************************/

WINDOW *maske2(win, m, x)
  int  x, m;
  WINDOW *win;

{
    if (m == W_DEL) {
	delwin(win);
	return (NULL);
    }
    if (m == W_NEW) {
	win = newwin(17, 39, 6, x);
	if (colors) {
	    wattrset(win, COLOR_PAIR(3) | A_BOLD);
	    werase(win);
	}
    }
    if (colors) {
	wattrset(win, COLOR_PAIR(3) | A_BOLD);
	mvwaddstr(win, 1, 1, "     File        Size    Date   Time ");
	mvwaddstr(win, 2, 1, "                                     ");
	mvwaddstr(win, 15, 1, "                                     ");
    }
    else {
	wattrset(win, A_REVERSE);
	mvwaddstr(win, 1, 6, "File");
	mvwaddstr(win, 1, 18, "Size");
	mvwaddstr(win, 1, 26, "Date");
	mvwaddstr(win, 1, 33, "Time");
    }
    if (colors)
	wattrset(win, COLOR_PAIR(1));
    else
	wattrset(win, A_NORMAL);
    box(win, ACS_VLINE, ACS_HLINE);
    mvwaddch(win, 1, 15, ACS_VLINE);
    mvwaddch(win, 1, 24, ACS_VLINE);
    mvwaddch(win, 1, 31, ACS_VLINE);
    mvwaddch(win, 2, 15, ACS_VLINE);
    mvwaddch(win, 2, 24, ACS_VLINE);
    mvwaddch(win, 2, 31, ACS_VLINE);
    mvwaddch(win, 15, 15, ACS_VLINE);
    mvwaddch(win, 15, 24, ACS_VLINE);
    mvwaddch(win, 15, 31, ACS_VLINE);
    return (win);
}

/********************************* maske3 **********************************/

WINDOW *maske3(win, m, mode)
  int  mode, m;
  WINDOW *win;

{
    if (m == W_DEL) {
	delwin(win);
	return (NULL);
    }
    if (m == W_NEW)
	win = newwin(1, 80, 24, 0);
    wmove(win, 0, 0);
    wclrtoeol(win);
    if (!mode) {
	if (colors)
	    wattrset(win, COLOR_PAIR(4));
	mvwaddstr(win, 0, 0, "1     2      3     4     5     6     7      8      9      10     11      12");
    }
    else {
	if (colors)
	    wattrset(win, COLOR_PAIR(4) | A_REVERSE);
	mvwaddstr(win, 0, 0, "                                                                               ");
    }
    if (!mode) {
	if (colors)
	    wattrset(win, COLOR_PAIR(2) | A_REVERSE);
	else
	    wattron(win, A_REVERSE);
    }
    mvwaddstr(win, 0, 1, "Help");
    mvwaddstr(win, 0, 7, "State");
    mvwaddstr(win, 0, 14, "View");
    mvwaddstr(win, 0, 20, "Edit");
    mvwaddstr(win, 0, 26, "Copy");
    mvwaddstr(win, 0, 32, "Move");
    mvwaddstr(win, 0, 38, "MkDir");
    mvwaddstr(win, 0, 45, "Erase");
    mvwaddstr(win, 0, 52, "Chmod");
    mvwaddstr(win, 0, 60, "Find");
    mvwaddstr(win, 0, 67, "Comp");
    mvwaddstr(win, 0, 75, "Quit");
    if (!colors)
	wattroff(win, A_REVERSE);
    return (win);
}

/********************************* maske4 **********************************/

WINDOW *maske4(win, m)
  int  m;
  WINDOW *win;
{
    if (m == W_DEL) {
	delwin(win);
	return (NULL);
    }
    if (m == W_NEW)
	win = newwin(5, 21, 5, 30);
    if (colors) {
	wattrset(win, COLOR_PAIR(4) | A_REVERSE);
	werase(win);
    }
    box(win, ACS_VLINE, ACS_HLINE);
    return (win);
}

/********************************* maske5 **********************************/

WINDOW *maske5(win, m)
  int  m;
  WINDOW *win;

{
    if (m == W_DEL) {
	delwin(win);
	return (NULL);
    }
    if (m == W_NEW)
	win = newwin(5, 60, 11, 9);
    if (colors) {
	wattrset(win, COLOR_PAIR(4) | A_REVERSE);
	werase(win);
    }
    box(win, ACS_VLINE, ACS_HLINE);
    return (win);
}

/********************************* maske6 **********************************/
WINDOW *maske6(win, m)
  int  m;
  WINDOW *win;

{
    int  i;

    if (m == W_DEL) {
	delwin(win);
	return (NULL);
    }
    if (m == W_NEW)
	win = newwin(20, 60, 3, 10);
    if (colors) {
	wattrset(win, COLOR_PAIR(4) | A_REVERSE);
	werase(win);
    }
    box(win, ACS_VLINE, ACS_HLINE);
    wmove(win, 17, 1);
    for (i = 0; i < 58; i++)
	waddch(win, ACS_HLINE);
    mvwaddch(win, 18, 41, ACS_VLINE);
    if (colors)
	wattrset(win, COLOR_PAIR(7) | A_BOLD);
    mvwaddstr(win, 18, 3, "D I R E C T O R Y - C O M M A N D E R");
    if (colors)
	wattrset(win, COLOR_PAIR(8));
    mvwaddstr(win, 18, 44, " F12 -> quit");
    if (colors)
	wattrset(win, COLOR_PAIR(4) | A_REVERSE);
    return (win);
}
